<template>
  <div class="sa-filter" data-testid="filters">
    <template v-if="filters.length">
      <label class="label">Filters</label>
      <div class="filter-inputs">
        <div
          v-for="filter in filters"
          :key="filter.id"
          :data-testid="filter.id"
          class="filter-wrapper"
        >
          <label
            v-if="showNamesAboveSelection"
            :class="filterLabelClasses(filter)"
          >
            {{ filter.title }}
          </label>
          <sa-select
            v-if="filter.type === 'select'"
            :key="filterKey(filter.id)"
            size="small"
            :label="filter.title"
            :multiselect="isMultiselect(filter)"
            :typeahead="isTypeahead(filter)"
            :max-options="maxOptions"
            :options="filter.options"
            :initial-selection="filter.initialSelection"
            @change="(selected) => updateFilter(filter.id, selected)"
          />
          <sa-multisearch
            v-else-if="filter.type === 'multisearch'"
            :key="filterKey(filter.id)"
            size="small"
            :label="filter.title"
            :initial-selection="filter.initialSelection"
            :filter-id="filter.id"
            @change="(selected) => updateFilter(filter.id, selected)"
          />
          <sa-select-date-range
            v-else
            :key="filterKey(filter.name)"
            size="small"
            :label="filter.title"
            :initial-range="filter.initialRange"
            :fields="filter.fields"
            @change="(range) => updateFilter(filter.name, range)"
          />
        </div>
        <div v-if="showSearch" class="filter-wrapper" data-testid="search">
          <sa-input-search
            :key="filterKey('search')"
            :placeholder="searchPlaceholder"
            size="small"
            :initial-value="searchTerm"
            @change="(search) => updateFilter(searchKey, search)"
          ></sa-input-search>
        </div>
      </div>
    </template>
    <span v-if="meta" class="meta">
      {{ pluralize('% result', fetched) }}
      <span v-if="meta.total_filtered_results !== meta.total_results">
        out of {{ formatNumber(meta.total_results) }}
      </span>
    </span>
  </div>
</template>

<script>
import tableStore from '../../mixins/tableStore'
import { FILTER_TYPES, DATATYPES } from '@/data/constants'

export default {
  name: 'SaFilter',
  mixins: [tableStore],
  props: {
    /** Show a search input box after the filters */
    showSearch: {
      type: Boolean,
      default: true
    },
    /** Placeholder text for search input box */
    searchPlaceholder: {
      type: String,
      default: 'Search'
    },
    /** Query string parameter to use for search text */
    searchKey: {
      type: String,
      default: 'q'
    },
    /** Most filters use the field ID as their key but the date range is special
     *  as it includes a field picker. You shouldn't need to change this. */
    dateRangeKey: {
      type: String,
      default: 'daterange'
    },
    /** Show filter label above the input when a value has been selected */
    showNamesAboveSelection: {
      type: Boolean,
      default: false
    },
    /** Automatically switch to a typeahead filter if the number of options exceeds this */
    maxOptions: {
      type: Number,
      default: 100
    },
    /** Store filter selection state in the page URL and keep them in sync with Vue router. */
    hasQueryParams: {
      type: Boolean,
      default: true
    }
  },
  data() {
    return {
      modelCallbacks: [],
      version: 0
    }
  },
  computed: {
    filters() {
      const filters = []
      // check if model and has filters
      if (this.model && this.model.filters) {
        const stateFilters = this.tableFilters
        // get filters with assigned field IDs
        const validFilters = this.model.filters.filter(
          (filter) => filter.fieldIds.length > 0
        )
        for (const filter of validFilters) {
          // daterange filter
          if (filter.type === FILTER_TYPES.DateRange) {
            const options = []
            // add each fieldId to options
            filter.fieldIds.forEach((fieldId) => {
              const field = this.findField(fieldId)
              if (field) {
                options.push({
                  value: field.id,
                  label: field.title
                })
              }
            })
            // if options add to daterange fields
            if (options.length > 0) {
              filters.push({
                id: 'date-range',
                title: 'Date Range',
                name: this.dateRangeKey,
                type: 'daterange',
                initialRange: stateFilters && stateFilters[this.dateRangeKey],
                fields: options
              })
            }
          } else {
            const type =
              filter.type === FILTER_TYPES.Multisearch
                ? 'multisearch'
                : 'select'
            const field = this.findField(filter.fieldIds[0])
            if (field) {
              filters.push({
                id: field.id,
                title: field.title,
                type,
                mode: filter.type,
                name: field.name,
                options: filter.options,
                initialSelection:
                  stateFilters && field.id in stateFilters
                    ? stateFilters[field.id]
                    : []
              })
            }
          }
        }
      }
      return filters
    },
    tableState() {
      return this.tableStore.state
    },
    meta() {
      return this.tableState.meta
    },
    model() {
      return this.tableState.model
    },
    tableFilters() {
      return this.tableState.filters
    },
    routeQuery() {
      return this.$route ? this.normaliseFilter(this.$route.query) : {}
    },
    fetched() {
      return this.meta ? this.meta.total_filtered_results : 0
    },
    searchTerm() {
      return this.tableFilters && this.tableFilters[this.searchKey]
    }
  },
  watch: {
    $route(to, from) {
      // if query params turned on and router query changes, update filters
      if (this.hasQueryParams && from.query !== to.query) {
        this.updateStoreFilters(this.routeQuery)
      }
    },
    model() {
      // when the model changes, call any functions waiting for it
      this.modelCallbacks.forEach((fn) => fn())
      this.modelCallbacks = []
    }
  },
  created() {
    // update filters if query params turned on and exist
    if (this.hasQueryParams) {
      const query = this.routeQuery
      if (!this.isEmpty(query)) {
        // if there's no model, wait for it
        if (this.model) {
          this.updateStoreFilters(query)
        } else {
          this.modelCallbacks.push(() => this.updateStoreFilters(query))
        }
      }
    }
  },
  beforeMount() {
    // update components when navigating back/forward
    window.addEventListener('popstate', this.incrementVersion)
  },
  beforeDestroy() {
    // reset filters
    this.tableStore.dispatch('setFilters', {})
    // remove listeners
    window.removeEventListener('popstate', this.incrementVersion)
  },
  methods: {
    incrementVersion() {
      this.version++
    },
    filterKey(id) {
      return id + this.version
    },
    normaliseFilter(filter) {
      const normalised = {}
      if (filter) {
        for (const [key, value] of Object.entries(filter)) {
          if (key === this.searchKey) {
            normalised[key] = value
          } else {
            normalised[key] = Array.isArray(value) ? value : [value]
          }
        }
      }
      return normalised
    },
    updateStoreFilters(query) {
      const filters = { ...query }
      // transform daterange query
      const dateFieldKey = this.dateRangeKey + '_field'
      if (dateFieldKey in filters) {
        const removeFilter = (key) => {
          const value = filters[key] || [null]
          delete filters[key]
          return value[0]
        }
        filters[this.dateRangeKey] = {
          field: removeFilter(this.dateRangeKey + '_field'),
          from: removeFilter(this.dateRangeKey + '_from'),
          to: removeFilter(this.dateRangeKey + '_to')
        }
      }
      // transform boolean strings
      for (const [key, value] of Object.entries(filters)) {
        if (value[0] === 'true' || value[0] === 'false') {
          filters[key] = [JSON.parse(value[0])]
        }
      }
      // remove any invalid filters
      for (const key of Object.keys(filters)) {
        if (!this.findFilter(key) && key !== this.searchKey) {
          delete filters[key]
        }
      }
      // dispatch filters
      this.tableStore.dispatch('setFilters', filters)
    },
    isMultiselect(filter) {
      return [
        FILTER_TYPES.MultiSelect,
        FILTER_TYPES.MultiSelect_Typeahead
      ].includes(filter.mode)
    },
    isTypeahead(filter) {
      // use a typeahead for explicitly set filters, or for those with too many options
      return (
        filter.options.length > this.maxOptions ||
        [
          FILTER_TYPES.Select_Typeahead,
          FILTER_TYPES.MultiSelect_Typeahead
        ].includes(filter.mode)
      )
    },
    findField(id) {
      return this.findFieldInArray(id, this.model.fields)
    },
    findFilter(key) {
      return this.model.filters.find(
        (filter) =>
          (filter.type === FILTER_TYPES.DateRange &&
            key === this.dateRangeKey) ||
          filter.fieldIds.includes(key)
      )
    },
    // looks for a matching field in the given array of fields.
    findFieldInArray(id, fields) {
      for (const field of fields) {
        // if top level id matches, return field
        if (field.id === id) {
          return field
        }
        // if subfield matches, return subfield
        const subfield = field.subfields
          ? field.subfields.find((field) => field.id === id)
          : undefined
        if (subfield) {
          return subfield
        }
        // if event and started or done id matches, return match
        if (field.type === DATATYPES.Event) {
          const started = field.started.id === id ? field.started : null
          const done = field.done.id === id ? field.done : null
          if (started) {
            return {
              ...started,
              title: field.title + ' Start'
            }
          } else if (done) {
            return {
              ...done,
              title: field.title + ' End'
            }
          }
        }
      }
      return null
    },
    filterLabelClasses(filter) {
      const classes = ['filter-label']
      if (this.tableFilters && this.tableFilters[filter.id]) {
        classes.push('active')
      }
      return classes
    },
    // Called when one of the filters changes.
    // Either updates the store directly (if query params turned off),
    // or indirectly via changing the query params (if query params on)
    updateFilter(filter, selected) {
      // null if daterange not selected or value empty
      if (filter === this.dateRangeKey) {
        if (!selected.field || (!selected.from && !selected.to)) {
          selected = null
        }
      } else if (!selected.length) {
        selected = null
      }

      // return if value has not changed
      const existing = this.tableFilters[filter]
      const changed = selected
        ? JSON.stringify(selected) !== JSON.stringify(existing)
        : !!existing
      if (!changed) {
        return
      }

      // if query params turned off, update filter in store
      if (!this.hasQueryParams) {
        this.tableStore.dispatch('updateFilter', {
          filter,
          selected
        })
        return
      }

      // if query params turned on, update params
      // 1. prepare query
      const newQueryParams = { ...this.$route.query }
      if (filter === this.dateRangeKey) {
        // transform or remove daterange params
        for (const key of ['field', 'from', 'to']) {
          if (selected && selected[key]) {
            newQueryParams[this.dateRangeKey + '_' + key] = selected[key]
          } else {
            delete newQueryParams[this.dateRangeKey + '_' + key]
          }
        }
      } else if (this.isEmpty(selected)) {
        // remove filter if cleared
        delete newQueryParams[filter]
      } else {
        // transform Boolean to string
        if (typeof selected[0] === 'boolean') {
          selected[0] = selected[0].toString()
        }
        newQueryParams[filter] = selected
      }
      // 2. push new params
      this.$router.push({ query: newQueryParams })
    }
  }
}
</script>
<style lang="scss" scoped>
.sa-filter {
  > * + * {
    margin-left: spacing(1);
  }
}

.filter-inputs {
  display: flex;
  align-items: center;
  flex-wrap: wrap;
}

.filter-wrapper {
  position: relative;
  margin: spacing(0);

  .filter-label {
    position: absolute;
    top: spacing(1);
    font-size: font-size(0);
    transform: translateY(-#{font-size(0)});
    opacity: 0;
    color: color(grey);

    &.active {
      opacity: 1;
    }
  }
}

.meta {
  font-size: font-size(0);
  color: color(grey);
}
</style>
